.686
.model flat,stdcall 
option casemap:none
.xmm

include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data
align 16
  actarr db   1,  3,  2,  3,  16,  6,  9, 48,  14,  8, 42, 27,  19, 15,  7, 40
  maxarr db   5,  7, 11, 13,  17, 19, 23, 53,  29, 31, 59, 37,  41, 43, 47, 61

  ones16 db 16 dup(1)
  plus24 db 16 dup(2)
  xswap6 db 16 dup(6)

  zeroes dd 0         ;  k  ebx     plus24 db 2,2,2,2
         dd 0
  anycnt dd 0
  allcnt dd 0         ;  totals dd 0

  times  dd 10000000
  szCap  db "SS2",0
  P      dd 0
  PID    dd 0

  CrTm   dd 0, 0
  ExTm   dd 0, 0
  KnTm   dd 0, 0
  UsTm   dd 0, 0

  szFmt  db "%lu",13,10,"%lu",13,10,"%lu",13,10,"%lu",13,10,0
  szMsg  db 100 dup (0)


.code
start:
   movdqa   XMM0, xmmword ptr actarr   ; 0  actarr  a
   movdqa   XMM3, xmmword ptr maxarr   ; 3  maxarr  m
   movdqa   XMM1, xmmword ptr ones16   ; 1  16 1s   1
   movdqa   XMM4, xmmword ptr plus24   ; 4  plus24  p24
   movdqa   XMM2, xmmword ptr xswap6
   pxor     XMM6, XMM6     ; t = 0
   mov ebx, times  ; use ebx for times

manybites:
   paddb    XMM0, XMM4     ; a = a + p24                  ; add the 2 or 4

   movdqa   XMM7, XMM3
   pxor     XMM5, XMM5
   
   pcmpgtb  XMM7, XMM0
   pandn    XMM7, XMM3
   psubb    XMM0, XMM7

   pcmpeqb  XMM5, XMM0
   paddb    XMM5, XMM1
   psadbw   XMM5, XMM1
    
   pextrw   edi, XMM5, 0
   pextrw   esi, XMM5, 4

   add edi, esi

   cmp edi, 1
   sbb anycnt, -1
   add allcnt, edi
   
   pxor     XMM4, XMM2
   ; movdqa   plus24, XMM4   ; save it/update the copy in memory
   dec ebx         ; dec times
   jnz manybites

   invoke GetCurrentProcess
   mov P, eax
   invoke GetProcessTimes, P, addr CrTm, addr ExTm, addr KnTm, addr UsTm

   invoke wsprintf, addr szMsg, addr szFmt, anycnt, allcnt, KnTm+0, UsTm+0
   invoke MessageBox, NULL, addr szMsg, addr szCap, MB_OK
   invoke ExitProcess, NULL
end start